<?php

function alertes($config)
{
    $servers_conf = load_servers_conf();
    $allLastStats = allLastStats($config);
    $allStatsPVE = allLastStatsPVE($config);
    // Inutilisés
    // $AllStatsSauvegardes = AllStatsSauvegardes($config);
    // $AllLastVM = allLastStatsVM($config);

    $_SESSION['nb_alertes'] = 0;
    /*
     * init du tableau des alertes
     */
    $alertes["alive"] = [];
    $alertes["dskhome"] = [];
    $alertes["dskpve"] = [];
    foreach ($servers_conf as $cle => $valeur) {
        $uai = strtolower($valeur['fields']['uai']);
        /*
         * Serveurs injoignables
         */
        $etat = $servers_conf[$cle]['fields']['etat'] ?? "";
        if ("$etat" == "injoignable") {
            $since = (time() - $servers_conf[$cle]['fields']['alive']);
            $_SESSION['nb_alertes'] += 1;
            if ($since < 120) {
                $depuis = "$since secondes";
            } elseif ($since < 3600) {
                $since = intval($since / (60)) + 1;
                $depuis = "$since  minutes";
            } elseif ($since < 3600 * 24) {
                $since = intval($since / (3600)) + 1;
                $depuis = "$since heures";
            } else {
                $since = intval($since / (3600 * 24)) + 1;
                $depuis = "$since jours";
            }
            $alertes["alive"]["$uai"] = "Le serveur SE4FS $uai est injoignable depuis $depuis.";
        }
        /*
         * home pleins à plus de 80%
         */
        if ((key_exists($uai, $allLastStats)) && (key_exists('home', $allLastStats[$uai])) && ($allLastStats[$uai]['home'] > 80)) {
            $alertes["dskhome"]["$uai"] = "Le disque '/home' du serveur SE4FS $uai  est plein à " . $allLastStats[$uai]['home'] . "%.";
            $_SESSION['nb_alertes'] += 1;
        }
        /*
         * Espace du PVE
         */
        if (isset($allStatsPVE["pve-" . $uai])) {
            $diskTotal = $allStatsPVE["pve-" . $uai]['blocks'];
            $diskUsed = $allStatsPVE["pve-" . $uai]['used'];
            if (($diskTotal != 0) && ($diskTotal != "")) {
                $dskPVEPRC = round($diskUsed / $diskTotal * 100, 2);
                if ($dskPVEPRC > 60) {
                    $alertes["dskpve"]["$uai"] = "Le disque du serveur PVE de $uai est plein à " . $dskPVEPRC . "%.";
                    $_SESSION['nb_alertes'] += 1;
                }
            }
        }
    }
    return $alertes;
}

/*
 * Fabrique le bandeau déroulant des alertes
 */
function liste_alertes($config)
{
    $success = false;
    $liste_alertes = apcu_fetch('alertes', $success);
    if (! $success) {
        $liste_alertes = "";
        $alertes = alertes($config);
        foreach ($alertes["alive"] as $cle => $valeur) {
            $liste_alertes .= '<a class="dropdown-item d-flex align-items-center" href="?page=sds&host=' . $cle . '">
                                <div class="mr-3">
                                <div class="icon-circle bg-danger">
                                    <i class="fas fa-file-alt text-white"></i>
                                </div>
                                </div>
                                <div>
                                    <span class="font-weight-bold">
                                        ' . $valeur . '
                                    </span>
                                </div>
                                </a>';
        }
        foreach ($alertes["dskhome"] as $cle => $valeur) {
            $liste_alertes .= '<a class="dropdown-item d-flex align-items-center" href="?page=sds&host=' . $cle . '">
                                <div class="mr-3">
                                <div class="icon-circle bg-danger">
                                    <i class="fas fa-file-alt text-white"></i>
                                </div>
                                </div>
                                <div>
                                    <span class="font-weight-bold">
                                        ' . $valeur . '
                                    </span>
                                </div>
                                </a>';
        }
        foreach ($alertes["dskpve"] as $cle => $valeur) {
            $liste_alertes .= '<a class="dropdown-item d-flex align-items-center" href="?page=sds&host=' . $cle . '">
                                <div class="mr-3">
                                <div class="icon-circle bg-danger">
                                    <i class="fas fa-file-alt text-white"></i>
                                </div>
                                </div>
                                <div>
                                    <span class="font-weight-bold">
                                        ' . $valeur . '
                                    </span>
                                </div>
                                </a>';
        }
        apcu_add('alertes', $liste_alertes, 120);
    }
    return $liste_alertes;
}
?>