<?php

/*
 * une boite
 */
function html_box($xl, $md, $mb, $color, $titre, $content, $logo)
{
    $html = '<div class="col-xl-' . $xl . ' col-md-' . $md . ' mb-' . $mb . '">
                            <div class="card border-left-' . $color . ' shadow h-100 py-2">
                                <div class="card-body">
                                    <div class="row no-gutters align-items-center">
                                        <div class="col mr-2">
                                            <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                                                ' . $titre . '
                                                </div>
                                            <div class="h5 mb-0 font-weight-bold text-gray-800">
                                            ' . $content . '
                                            </div>
                                        </div>
                                        <div class="col-auto">
                                            <i class="' . $logo . ' text-gray-300"></i>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>';
    return $html;
}

function html_top($config, $page)
{
    /*
     * On charge seulement les scripts nécéssaires pour la page
     *
     *
     */
    switch ($page) {
        case "tdb":
            $scriptload = "openAtOpen();ShowStats('UsersOnline',1);";
            break;
        case "sds":
            if ((! array_key_exists("host", $_GET)) || ($_GET['host'] == "")) {
                $scriptload = "";
            } else {
                $scriptload = "ShowStats('CPU',1);ShowStats('RAM',2);ShowStats('UsersOnline',3);ShowStats('disks',4);ShowStats('nbUsersActivated',5);";
            }
            break;
        case "sdpve":
            if ((! array_key_exists("host", $_GET)) || ($_GET['host'] == "")) {
                $scriptload = "";
            } else {
                $scriptload = "ShowStats('CPU',1);ShowStats('RAM',2);ShowStats('nics',3);";
            }
            break;
        default:
            $scriptload = "";
            break;
    }
    $html = html_header($config, $page);
    $html .= '<body id="page-top" onload="' . $scriptload . '">
                <!-- Page Wrapper -->
                <div id="wrapper">';
    $html .= html_menu($config, $page);
    $html .= '<!-- Content Wrapper -->
            <div id="content-wrapper" class="d-flex flex-column">
            <!-- Main Content -->
            <div id="content">';
    $html .= html_topbar($config, $page);
    $html .= '<!-- Begin Page Content -->
            <div class="container-fluid">';
    return $html;
}

function html_header($config, $page)
{
    /*
     *
     * On ne charge que les JS nécéssaires
     *
     */
    switch ($page) {
        case "tdb":
            $scriptload = '<!-- Carte des serveurs -->
        <link rel="stylesheet" href="css/maps.css" />
        <script src="js/leaflet.js"></script>
        <link rel="stylesheet" type="text/css" href="https://unpkg.com/leaflet.markercluster@1.3.0/dist/MarkerCluster.css" />
        <link rel="stylesheet" type="text/css" href="https://unpkg.com/leaflet.markercluster@1.3.0/dist/MarkerCluster.Default.css" />
        <script type="text/javascript" src="https://unpkg.com/leaflet.markercluster@1.3.0/dist/leaflet.markercluster.js"></script>
        <!-- Giraffe pour les graphes de stats -->
        <script type="text/javascript" src="js/react.development.js"></script>
        <script type="text/javascript" src="js/react-dom.development.js"></script>
        <script type="text/javascript" src="js/giraffe.js"></script>';
            break;
        case "sds":
        case "sdpve":
            $scriptload = '<!-- Giraffe pour les graphes de stats -->
        <script type="text/javascript" src="js/react.development.js"></script>
        <script type="text/javascript" src="js/react-dom.development.js"></script>
        <script type="text/javascript" src="js/giraffe.js"></script>';
            break;
        default:
            $scriptload = "";
            break;
    }

    $html = '
    <!DOCTYPE html>
    <html lang="fr">
        
    <head>
        
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
        <meta name="description" content="">
        <meta name="author" content="">
        
        <title>' . $config['CentralTitle'] . '</title>
            
        <!-- Custom fonts for this template Nunito-->
        <link href="../vendor/fortawesome/font-awesome/css/all.min.css" rel="stylesheet" type="text/css">
        <!-- Inutilisé
        <link href="https://fonts.googleapis.com/css?family=Orbitron:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">
        -->
            
        <!-- Custom styles for this template-->
        <link href="css/sb-admin-2.min.css" rel="stylesheet">
            
        <link href="js/datatables/dataTables.bootstrap4.min.css" rel="stylesheet">
        ' . $scriptload . '
            
    </head>
    ';

    return $html;
}

function html_footer($config, $page)
{
    /*
     * Serveur à charger par défault
     */
    $DefaultUAI = "0952282p";
    /*
     *
     * On ne charge que les JS nécéssaires
     *
     */
    switch ($page) {
        case "tdb" :
            /*
             * Par déaut on charge le serveur central
             *
             */
            $host = $_GET['host'] ?? "0000000x";
            $scriptload = '
    <!-- Scripts pour la carte interactive -->
    <script type="text/javascript">
    geojson =
    ' . file_get_contents("conf/geojson2.json") . '
        
        
    central_uri = "' . $config['central_uri'] . '";
        
    </script>
    <script type="text/javascript" src="js/carte_serveurs.js"></script>
        
        
    <!-- Scripts pour le graph des stats -->
    <script>
    function ShowStats(quoi,i)
    {
        if (quoi === "Users") {
            var fluxResponse = `' . StatsServeur($config, "Users", $host) . '`
        } else if (quoi === "RAM"){
            document.getElementById("txtStatsTDB").textContent = "RAM utilisée";
            var fluxResponse = `' . StatsServeur($config, "Ram", $host) . '`
        } else if (quoi === "UsersOnline") {
            document.getElementById("txtStatsTDB").textContent = "Nombre d\'utilisateurs connectés";
            var fluxResponse = `' . StatsServeur($config, "NbUsersConnected") . '`
        } else if (quoi === "CPU") {
            document.getElementById("txtStatsTDB").textContent = "CPU utilisé";
            var fluxResponse = `' . StatsServeur($config, "CPU", $host) . '`
        } else if (quoi === "disks") {
            var fluxResponse = `' . StatsServeur($config, "disks", $host) . '`
        }
        GraphStats(quoi,i,fluxResponse);
    }
    </script>';
            break;
        case "sds" :
            /* On charge le JS de giraffe pour les stats graphés des SE4
             //~ *
             */
            $host = $_GET['host'] ?? "";

            if ($host != "") {
                $scriptload = '<!-- Scripts pour le graph des stats -->
        <script>
        function ShowStats(quoi,i)
        {
               if (quoi === "Users") {
                    var fluxResponse = `' . StatsServeur($config, "Users", $host) . '`
                } else if (quoi === "RAM"){
                    var fluxResponse = `' . StatsServeur($config, "Ram", $host) . '`
                } else if (quoi === "UsersOnline") {
                    var fluxResponse = `' . StatsServeur($config, "NbUsersConnected", $host) . '`
                } else if (quoi === "CPU") {
                    var fluxResponse = `' . StatsServeur($config, "CPU", $host) . '`
                } else if (quoi === "disks") {
                    var fluxResponse = `' . StatsServeur($config, "disks", $host) . '`
                }  else if (quoi === "nbUsersActivated") {
                    var fluxResponse = `' . StatsServeur($config, "nbUsersActivated", $host) . '`
                }
                GraphStats(quoi,i,fluxResponse);
        }
        </script>';
            } else {
                $scriptload = '
                    
    <!-- Page level plugins -->
    <script src="js/datatables/jquery.dataTables.min.js"></script>
    <script src="js/datatables/dataTables.bootstrap4.min.js"></script>
                    
    <!-- Page level custom scripts -->
    <script src="js/datatables.js"></script>
    ';
            }
            break;

        case "sdpve" :
            /* On charge le JS de giraffe pour les stats graphés des PVE
             *
             */
            $host = $_GET['host'] ?? "";

            if ($host != "") {
                $scriptload = '
        <script>
        function ShowStats(quoi,i)
        {
                if (quoi === "CPU") {
                    var fluxResponse = `' . StatsServeurPVE($config, "CPU", "pve-" . $host) . '`
                } else if (quoi === "RAM"){
                    var fluxResponse = `' . StatsServeurPVE($config, "RAM", "pve-" . $host) . '`
                } else if (quoi === "nics"){
                    var fluxResponse = `' . StatsServeurPVE($config, "nics", "pve-" . $host) . '`
                }
                GraphStats(quoi,i,fluxResponse);
        }
        </script>';
            } else {
                $scriptload = '
                    
    <!-- Page level plugins -->
    <script src="js/datatables/jquery.dataTables.min.js"></script>
    <script src="js/datatables/dataTables.bootstrap4.min.js"></script>
                    
    <!-- Page level custom scripts -->
    <script src="js/datatables.js"></script>
    ';
            }
            break;
        case "test":
            $scriptload = '';
            break;

        default:
            $scriptload = "";
            break;
    }

    $html = '
            </div><!-- container fluid -->
           <!-- Footer -->
            <footer class="sticky-footer bg-white">
                <div class="container my-auto">
                    <div class="copyright text-center my-auto">
                        <span>Copyright &copy; IRUNDO</span>
                    </div>
                </div>
            </footer>
            <!-- End of Footer -->
        </div><!-- End of Content -->
    </div><!-- End of Page content Wrapper -->
    </div><!-- End of Page Wrapper -->
    <!-- Scroll to Top Button-->
    <a class="scroll-to-top rounded" href="#page-top">
        <i class="fas fa-angle-up"></i>
    </a>
    <!-- Logout Modal-->
    <div class="modal fade" id="logoutModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Se déconnecter ?</h5>
                    <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                </div>
                <div class="modal-body">Déconnexion de la session....</div>
                <div class="modal-footer">
                    <button class="btn btn-secondary" type="button" data-dismiss="modal">Annuler</button>
                    <a class="btn btn-primary" href="login.php">Déconnexion</a>
                </div>
            </div>
        </div>
    </div>
    <!-- Bootstrap core JavaScript-->
    <script src="js/jquery/jquery.min.js"></script>
    <script src="js/bootstrap/js/bootstrap.bundle.min.js"></script>
        
    <!-- Custom scripts for all pages-->
    <script src="js/sb-admin-2.min.js"></script>
    <script src="js/central_ui.js"></script>
        
        
    ' . $scriptload . '
    </body>
    </html>
    ';
    return $html;
}

function html_topbar($config, $page)
{
    $liste_alertes = liste_alertes($config);
    $ServersConfArray = ServersConfArray();
    /*
     * Liste des serveurs pour la recherche autocomplétée
     */
    $dataListUAI = '<datalist id="list-UAI">
    ';
    foreach ($ServersConfArray as $cle => $valeur) {
        if ($valeur['etat'] != "inactif") {
            $dataListUAI .= '<option value="' . $valeur['uai'] . '">' . $valeur['uai'] . ' (' . $valeur['name'] . ')</option>
            ';
        }
    }
    $dataListUAI .= '</datalist>
    ';
    return '
                    <!-- Topbar -->
                <nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">
        
                    <!-- Sidebar Toggle (Topbar) -->
                    <button id="sidebarToggleTop" class="btn btn-link d-md-none rounded-circle mr-3">
                        <i class="fa fa-bars"></i>
                    </button>
        
                    <!-- Topbar Search -->
                    ' . $dataListUAI . '
                    <form
                        class="d-none d-sm-inline-block form-inline mr-auto ml-md-3 my-2 my-md-0 mw-100 navbar-search">
                        <div class="input-group">
                            <input id ="SearchUAI" type="text" class="form-control bg-light border-0
                                small" placeholder="Accès direct..."
                                aria-label="Search" aria-describedby="basic-addon2"
                                list="list-UAI"
                                >
                            <div class="input-group-append">
                                <button class="btn btn-primary" type="button" onClick="Search();">
                                    <i class="fas fa-search fa-sm"></i>
                                </button>
                            </div>
                        </div>
                    </form>
                    <!-- -->
                    <!-- Topbar Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <div class="topbar-divider d-none d-sm-block"></div>
                        
                        <!-- Centre d alertes -->
                        <li class="nav-item dropdown no-arrow mx-1">
                            <a class="nav-link dropdown-toggle" href="#" id="alertsDropdown" role="button"
                                data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <i class="fas fa-bell fa-fw"></i>
                                <!-- Counter - Alerts -->
                                <span class="badge badge-danger badge-counter">' . $_SESSION['nb_alertes'] . '</span>
                            </a>
                            <!-- Dropdown - Alerts -->
                            <div class="dropdown-list dropdown-menu dropdown-menu-right shadow animated--grow-in"
                                aria-labelledby="alertsDropdown ">
                                <h6 class="dropdown-header bg-gradient-danger">
                                    Liste des alertes
                                </h6>
                                ' . $liste_alertes . '
                            </div>
                        </li>
                                    
                        <!-- Nav Item - User Information -->
                        <li class="nav-item dropdown no-arrow">
                            <a class="nav-link dropdown-toggle" href="#" id="userDropdown" role="button"
                                data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <span class="mr-2 d-none d-lg-inline text-gray-600 small">
                                ' . $_SESSION['username'] . '
                                </span>
                                <img class="img-profile rounded-circle"
                                    src="img/undraw_profile.svg">
                            </a>
                            <!-- Dropdown - User Information -->
                            <div class="dropdown-menu dropdown-menu-right shadow animated--grow-in"
                                aria-labelledby="userDropdown">
                                <a class="dropdown-item" href="#">
                                    <i class="fas fa-user fa-sm fa-fw mr-2 text-gray-400"></i>
                                    Profil
                                </a>
                                <a class="dropdown-item" href="#">
                                    <i class="fas fa-cogs fa-sm fa-fw mr-2 text-gray-400"></i>
                                    Paramètres
                                </a>
                                <a class="dropdown-item" href="#">
                                    <i class="fas fa-list fa-sm fa-fw mr-2 text-gray-400"></i>
                                    Historique des connexions
                                </a>
                                <div class="dropdown-divider"></div>
                                <a class="dropdown-item" href="#" data-toggle="modal" data-target="#logoutModal">
                                    <i class="fas fa-sign-out-alt fa-sm fa-fw mr-2 text-gray-400"></i>
                                    Déconnexion
                                </a>
                            </div>
                        </li>
                    </ul>
                </nav>
                <!-- End of Topbar -->
                ';
}

/*
 * Menu accordéon
 * A partir du JSON
 */
function html_menu($config, $page)
{
    $menu_json = file_get_contents("conf/menu.json");
    $menu = json_decode($menu_json);
    $html = '<!-- Sidebar -->
            <ul class="navbar-nav bg-gradient-primary sidebar sidebar-dark accordion" id="accordionSidebar">
                <!-- Sidebar - Brand -->
        
                <a class="sidebar-brand d-flex align-items-center justify-content-center" href="?">
                    <img src="./img/vdo.png" class="img-fluid mx-auto" width="30%">
                    <div class="sidebar-brand-text mx-3 text-xs">' . $config['CentralTitle'] . '
                    </div>
                </a>
                        
                <!-- Divider -->
                <hr class="sidebar-divider my-0">';
    $compteur = 0;
    foreach ($menu->menu as $cle => $valeur) {
        $ACTIVE = "";
        if ($valeur->sep) {
            $html .= '<hr class="sidebar-divider">';
        }
        if ($valeur->title) {
            $html .= '<div class="sidebar-heading">' . $valeur->title . '</div>';
        }
        if ($valeur->cat == "item") {
            if ("$page" == "$valeur->url") {
                $ACTIVE = "active";
            }
            $html .= '<li class="nav-item ' . $ACTIVE . '">
                      <a class="nav-link" href="index.php?page=' . $valeur->url . '">
                      <i class="fas ' . $valeur->icone . ' "></i>
                      <span>' . $valeur->name . '</span></a>
                      </li>';
        } elseif ($valeur->cat == "parent") {
            $compteur ++;
            // si $page est dans $valeur->submenus->***->url ??
            $SHOW = "";
            foreach ($valeur->submenus as $cle2 => $valeur2) {
                if ("$valeur2->url" == "$page") {
                    $SHOW = "show";
                }
            }
            $html .= '<li class="nav-item">
                    <a class="nav-link collapsed" href="#" data-toggle="collapse" data-target="#collapse' . $compteur . '"
                        aria-expanded="true" aria-controls="collapse' . $compteur . '">
                        <i class="fas ' . $valeur->icone . '"></i>
                        <span>' . $valeur->name . '</span>
                    </a>
                    <div id="collapse' . $compteur . '" class="collapse ' . $SHOW . '" aria-labelledby="headingTwo" data-parent="#accordionSidebar">
                        <div class="bg-white py-2 collapse-inner rounded">';
            foreach ($valeur->submenus as $cle2 => $valeur2) {
                if ("$page" == "$valeur2->url") {
                    $ACTIVE = "active";
                } else {
                    $ACTIVE = "";
                }
                $html .= '<a class="collapse-item ' . $ACTIVE . '" href="index.php?page=' . $valeur2->url . '">' . $valeur2->name . '</a>';
            }
            $html .= '</div></div></li>';
        }
    }

    $html .= '<!-- Sidebar Toggler (Sidebar) -->
                <div class="text-center d-none d-md-inline">
                    <button class="rounded-circle border-0" id="sidebarToggle"></button>
                </div>
        
                <!-- Sidebar Message -->
                <div class="sidebar-card d-none d-lg-flex">
        
                    <img src="./img/IRUNDO.png" width="90%">
                    <p class="text-center mb-2">IRUNDO</p>
                </div>
            </ul>
            <!-- End of Sidebar -->';
    return $html;
}

function html_content($config, $page)
{
    /*
     * Lit la conf des serveurs
     */
    $ServersConfArray = ServersConfArray();
    /*
     * Séparer la gestion de chaque page dans des php différents ?
     */
    $html = "";
    switch ($page) {
        case "tdb" :
            /*
             *On charge la page TDB
             */
            tdb($config, $html);
            break;
        case "sds" :
            /*
             *On charge la page Stats des SE4
             */
            sds($config, $ServersConfArray, $html);
            break;
        case "auns": // ACTIVATION d'un site $$
            /*
             * On charge la page d'activation d'un site
             */
            auns($config, $ServersConfArray, $html);
            break;

        case 'r': // Recherche annuaire
            /*
             * Annuaire
             */
            annu_central($config, $html);
            break;

        case 'fde':
            /*
             * Fonds d'écran
             */
            $ServersConfArray = ServersConfArray();
            $ServerChoice = "<select name=\"ServerToModify\" multiple size=\"4\">";
            foreach ($ServersConfArray as $cle => $valeur) {
                if ($valeur['etat'] != "inactif") {
                    $DefaultUAI = strtolower($valeur['uai']);
                    $ServerChoice .= '<option value="' . $valeur['uai'] . 'Chien">' . $valeur['uai'] . ' (' . $valeur['name'] . ')</option>' . '">';
                }
            }
            $ServerChoice .= '</select>';
            $titre = "Modification des fonds d'écran d'une selection ou de tous les serveurs.";
            $content = "";
            $content .= "<h3>Choix des serveurs à modifier :</h3>";
            $content .= "<h6>" . $ServerChoice . "</h6>";
            $html .= html_box(12, 6, 4, "success", $titre, $content, "fas fa-address-card fa-3x");
            $titre = "Utiliser un des fonds d'écran disponible ou enrichir le catalogue.";
            $content = "";
            $content .= "";
            $content .= "";
            $html .= html_box(12, 6, 4, "success", $titre, $content, "fas fa-address-card fa-3x");
            break;
        case 'sdpve' :
            /*
             *On charge la page de stat des PVE
             */
            sdpve($config, $ServersConfArray, $html);
            break;
        case 'eds' :
            /*
             *On charge la page de stat des Sauvegardes
             */
            eds($config, $ServersConfArray, $html);
            break;
        case 'dda':
            dda($config, $ServersConfArray, $html);
            break;
        default:
            break;
    }

    return $html;
}

?>